%define name scilab 
%define version 4.0
%define release %mkrel 3

%define flavor emacs

Summary: A high-level language for numerical computations
Name: %name
Version: %version
Release: %release
License: SCILAB
Group: Sciences/Mathematics
# CAUTION: pristine source is actually tar.gzipped
Source0: ftp://ftp.inria.fr/INRIA/Projects/Meta2/Scilab/distributions/%{name}-%{version}-src.tar.bz2
Source20: scilab.el
URL: http://scilabsoft.inria.fr/
BuildRequires: perl tcl-devel tk-devel Xaw3d-devel gtkhtml2-devel vte-devel 
BuildRequires: emacs-nox libgcj-devel gcc-gfortran 
BuildRequires: gcc-java ocaml
BuildRequires: ImageMagick sablotron
BuildRequires: libpvm-devel java-1.4.2-gcj-compat-devel
BuildRoot: %{_tmppath}/%name-buildroot
Excludearch: sparc ia64

%description
Scilab is a high-level language, primarily intended for numerical
computations.  Scilab includes a number of toolboxes and on-line
documentation.

This package is in PLF because of Mandriva Linux policy forbidding 
non-free softwares.

%prep
rm -rf $RPM_BUILD_ROOT
%setup -q 

%build
%__libtoolize --copy --force
export CFLAGS="$RPM_OPT_FLAGS"
export CC_OPTIONS="$RPM_OPT_FLAGS"
export CXXFLAGS="$RPM_OPT_FLAGS"
export FFLAGS="$RPM_OPT_FLAGS"
export FC_OPTIONS="$RPM_OPT_FLAGS"
rm -f config.cache
# ignore java include check
perl -pi -e "s/JAVASCITARGET=javasci-bidon/JAVASCITARGET=scilex-lib/" m4/java.m4
autoconf
%configure --enable-shared --with-java --enable-static=no --with-xaw3d --with-tk

# fix java include path
perl -pi -e "s/JAVAINC=.*/JAVAINC=/" routines/Javasci/Makefile

make FC_OPTIONS="$RPM_OPT_FLAGS" CC_OPTIONS="$RPM_OPT_FLAGS" all
make tarbindist 2>&1 > /dev/null

cp -af %SOURCE20 .
for i in %{flavor};do
	$i -batch -q -no-site-file -f batch-byte-compile %{name}.el
	mv %{name}.elc $i-%{name}.elc
done



%install
rm -rf $RPM_BUILD_ROOT
#makeinstall

mkdir -p $RPM_BUILD_ROOT{%_libdir,%_bindir}
pushd $RPM_BUILD_ROOT%_libdir
   tar xf $RPM_BUILD_DIR/scilab-%{version}/scilab-4.*-bin.tar
popd

# Nuke dependencies on /bin/SCILABGS and /bin/sh5
pushd $RPM_BUILD_ROOT%_libdir/scilab-*
    chmod -x ./scripts/scilab.g
    perl -pi -e s+/bin/sh5+/bin/sh+ ./bin/dold
popd

# Nuke attempts to setenv SCI from build directory.
pushd $RPM_BUILD_ROOT%_libdir/scilab-*
  for F in `grep -l ${RPM_BUILD_DIR} ./util/* ./bin/*`
  do
    perl -pi -e "s+${RPM_BUILD_DIR}+%{_libdir}+" ${F}
  done
popd

# Add /usr/bin/scilab symlink
ln -s %_libdir/%name-%version/bin/scilab $RPM_BUILD_ROOT%_bindir/scilab

# Clean up some perms stuff so we don't get bogus dependencies
chmod a-x `find $RPM_BUILD_ROOT%_libdir/scilab-*/ -type f -name "Makefile.*"`

# Icons
install -d $RPM_BUILD_ROOT/%{_miconsdir}
install -d $RPM_BUILD_ROOT/%{_liconsdir}
convert X11_defaults/%{name}.xpm -geometry 48x48 %{buildroot}%{_liconsdir}/%{name}.png
convert X11_defaults/%{name}.xpm -geometry 32x32 %{buildroot}%{_iconsdir}/%{name}.png
convert X11_defaults/%{name}.xpm -geometry 16x16 %{buildroot}%{_miconsdir}/%{name}.png

# Menu
install -d $RPM_BUILD_ROOT/%{_menudir}
cat << EOF > $RPM_BUILD_ROOT/%{_menudir}/%{name}
?package(%{name}):command="%{_bindir}/%{name}" icon="%{name}.png" \
                needs="X11" section="Applications/Sciences/Mathematics" \
		title="Scilab" \
                longtitle="Environment for numerical computations"
EOF

# (X)emacs
for i in %{flavor};do
	mkdir -p %{buildroot}%{_datadir}/$i/site-lisp/
	mkdir -p %{buildroot}%{_datadir}/emacs/site-lisp/
	install -m644 $i-%{name}.elc %{buildroot}%{_datadir}/$i/site-lisp/
	[[ $i = emacs ]] && install -m644 %{name}.el %{buildroot}%{_datadir}/emacs/site-lisp/
done

mkdir -p %buildroot%{_sysconfdir}/emacs/site-start.d
cat << EOF > %buildroot%{_sysconfdir}/emacs/site-start.d/%{name}.el
%{expand:%(%__cat %{SOURCE20})}
EOF


%post
%{update_menus}

%postun
%{clean_menus}


%clean
rm -rf $RPM_BUILD_ROOT
rm -f ../scilab-4.*-bin.tar

%files
%defattr(-,root,root)
%doc ACKNOWLEDGEMENTS CHANGES license.txt licence.txt
%_bindir/*
%_libdir/scilab-*
%{_miconsdir}/%{name}.png
%{_iconsdir}/%{name}.png
%{_liconsdir}/%{name}.png
%{_menudir}/%{name}
%config(noreplace) /etc/emacs/site-start.d/%{name}.el
%{_datadir}/*/site-lisp/*el*

%changelog
* Sat Sep 30 2006 Couriousous <couriousous@zarb.org> 4.0-3plf2007.0
- Rebuild

* Wed May  3 2006 Couriousous <couriousous@zarb.org> 4.0-2plf
- Add plf reason

* Sun Mar 19 2006 Couriousous <couriousous@zarb.org> 4.0-1plf
- 4.0

* Fri Feb  3 2006 Couriousous <couriousous@zarb.org> 3.1.1-3plf
- Rebuild

* Wed Jan  4 2006 Couriousous <couriousous@zarb.org> 3.1.1-2plf
- Rebuild
- Some fix from Pierre Lag

* Wed Oct 19 2005 Couriousous <couriousous@zarb.org> 3.1.1-1plf
- Move to plf, as scilab license is not free
- 3.1.1
- Remove xemacs mode, don't know how to fix it.
- Some dirty hack to make it compile

* Wed Sep 22 2004 Lenny Cartier <lenny@mandrakesoft.com> 3.0-3mdk
- fix executable link

* Sun Aug 15 2004 Lenny Cartier <lenny@mandrakesoft.com> 3.0-2mdk
- url

* Tue Aug 03 2004 Thierry Vignaud <tvignaud@mandrakesoft.com> 3.0-1mdk
- new release
- do not use subshells (b/c of error managment issues)

* Sat Aug 30 2003 Michael Scherer <scherer.michael@free.fr> 2.7-3mdk
- BuildRequires emacs-nox,xemacs instead of emacs 

* Tue Apr 08 2003 Olivier Thauvin <thauvin@aerov.jussieu.fr> 2.7-2mdk
- rebuild against tcl/tk

* Fri Feb 28 2003 Olivier Thauvin <thauvin@aerov.jussieu.fr> 2.7-1mdk
- 2.7

* Tue Jan 28 2003 Lenny Cartier <lenny@mandrakesoft.com> 2.6-4mdk
- rebuild

* Sun Jun 16 2002 Olivier Thauvin <thauvin@aerov.jussieu.fr> 2.6-3mdk
- png icons (out xpm!)

* Thu Dec 13 2001 Thierry Vignaud <tvignaud@mandrakesoft.com> 2.6-2mdk
- add emacs mode

* Tue Oct 09 2001 Lenny Cartier <lenny@mandrakesoft.com> 2.6-2mdk
- fixes from Thomas Leclerc <leclerc@linux-mandrake.com> :
	- use Xaw3d (fix crash when exporting graphics, see website)
	- BuildRequires: gcc-g77 Xaw3d-devel
	- use libtoolize

* Wed Jul 18 2001  Lenny Cartier <lenny@mandrakesoft.com> 2.6-1mdk
- updated by Thomas Leclerc <leclerc@linux-mandrake.com> :
	- updated to 2.6
	- menu entry and icons
	- included some RH spec changes
	- removed insertfield.f, mtlb_load.sci, and old patches
	- used RH patch nopvmdist


* Mon Feb 19 2001 Lenny Cartier <lenny@mandrakesoft.com> 2.5-1mdk
- updated to 2.5
- used patches from RH

* Tue Sep 26 2000 Lenny Cartier <lenny@mandrakesoft.com> 2.4.1-3mdk

- build release
- macros
- menu

* Wed May 03 2000 Lenny Cartier <lenny@mandrakesoft.com> 2.4.1-2mdk

- bzip2 patches
- fix group

* Thu Dec 30 1999 Lenny Cartier <lenny@mandrakesoft.com>

- new in contribs
- bz2 archive

* Wed Aug 18 1999 Tim Powers <timp@redhat.com>
- exludearch alpha

* Wed Jul 21 1999 Tim Powers <timp@redhat.com>
- rebuilt for 6.1

* Wed May 12 1999 Bill Nottingham <notting@redhat.com>
- clean up dependencies

* Wed May 05 1999 Bill Nottingham <notting@redhat.com>
- update to 2.4.1

* Fri Oct 23 1998 Jeff Johnson <jbj@redhat.com>
- Upgrade to 2.4.

* Thu Oct 22 1998 Jeff Johnson <jbj@redhat.com>
- Fixes to permit compile on alpha.
- Eliminate lurking dependencies on /bin/sh5 and SCILABGS.
- Modify default value of SCI variable to be correct for users.
- Add /usr/bin/scilab symlink.

* Sat Jul 11 1998 Jeff Johnson <jbj@redhat.com>
- Create powertools package.
